
datablock fxDtsBrickData(LogicGate_Rom16x8_Data){
	brickFile = $LuaLogic::Path @ "bricks/gen/newbricks/ROM 16x8.blb";
	iconName = $LuaLogic::Path @ "bricks/gen/newicons/ROM 16x8";
	
	category = "Logic Bricks";
	subCategory = "Special I/O";
	uiName = "ROM 16x8";
	logicUIName = "ROM 16x8";
	logicUIDesc = "";
	
	hasPrint = 1;
	printAspectRatio = "Logic";
	
	logicBrickSize = "16 8 1";
	orientationFix = 3;
	
	isLogic = true;
	isLogicGate = true;
	isLogicInput = false;
	
	logicInit = 
		"return function(gate) " @
		"	gate.romdata = {} " @
		"	for i = 0, 127 do " @
		"		gate.romdata[i] = 0 " @
		"	end " @
		"end"
	;
	logicInput = 
		"return function(gate, args) " @
		"	local data = args[1] " @
		"	for i = 1, #data do " @
		"		local c = data:sub(i, i) " @
		"		gate.romdata[i-1] = (c==\"1\") and 1 or 0 " @
		"	end " @
		"	Gate.queue(gate, 0) " @
		"end"
	;
	logicUpdate = 
		"return function(gate) " @
		"	if Gate.getportstate(gate, 9) then " @
		"		Gate.setportstate(gate, 8, gate.romdata[( " @
		"			(Gate.getportstate(gate, 1)) " @
		"			+ (Gate.getportstate(gate, 2) * 2) " @
		"			+ (Gate.getportstate(gate, 3) * 4) " @
		"			+ (Gate.getportstate(gate, 4) * 8) " @
		"			+ (Gate.getportstate(gate, 5) * 16) " @
		"			+ (Gate.getportstate(gate, 6) * 32) " @
		"			+ (Gate.getportstate(gate, 7) * 64) " @
		"		)]) " @
		"	else " @
		"		Gate.setportstate(gate, 8, 0) " @
		"	end " @
		"end"
	;
	logicGlobal = "";
	
	numLogicPorts = 9;
	
	isLogicRom = true;
	logicRomY = 8;
	logicRomX = 16;
	
	logicPortType[0] = 1;
	logicPortPos[0] = "15 -7 0";
	logicPortDir[0] = 3;
	logicPortUIName[0] = "Addr0";
	logicPortCauseUpdate[0] = true;
	
	logicPortType[1] = 1;
	logicPortPos[1] = "13 -7 0";
	logicPortDir[1] = 3;
	logicPortUIName[1] = "Addr1";
	logicPortCauseUpdate[1] = true;
	
	logicPortType[2] = 1;
	logicPortPos[2] = "11 -7 0";
	logicPortDir[2] = 3;
	logicPortUIName[2] = "Addr2";
	logicPortCauseUpdate[2] = true;
	
	logicPortType[3] = 1;
	logicPortPos[3] = "9 -7 0";
	logicPortDir[3] = 3;
	logicPortUIName[3] = "Addr3";
	logicPortCauseUpdate[3] = true;
	
	logicPortType[4] = 1;
	logicPortPos[4] = "7 -7 0";
	logicPortDir[4] = 3;
	logicPortUIName[4] = "Addr4";
	logicPortCauseUpdate[4] = true;
	
	logicPortType[5] = 1;
	logicPortPos[5] = "5 -7 0";
	logicPortDir[5] = 3;
	logicPortUIName[5] = "Addr5";
	logicPortCauseUpdate[5] = true;
	
	logicPortType[6] = 1;
	logicPortPos[6] = "3 -7 0";
	logicPortDir[6] = 3;
	logicPortUIName[6] = "Addr6";
	logicPortCauseUpdate[6] = true;
	
	logicPortType[7] = 0;
	logicPortPos[7] = "15 7 0";
	logicPortDir[7] = 1;
	logicPortUIName[7] = "Out";
	
	logicPortType[8] = 1;
	logicPortPos[8] = "15 -7 0";
	logicPortDir[8] = 2;
	logicPortUIName[8] = "In";
	logicPortCauseUpdate[8] = true;
	
};

function LogicGate_Rom16x8_Data::Logic_onAdd(%data, %brick) {
	lualogic_rom_updatedata(%brick);
}
